package com.adventurer_engine.client.model.tmt;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.adventurer_engine.client.model.tmt.ModelPoolEntry;
import com.adventurer_engine.client.model.tmt.ModelPoolObjEntry;
import com.adventurer_engine.client.model.tmt.TextureGroup;
import com.adventurer_engine.client.model.tmt.TransformGroup;
import cpw.mods.fml.common.Loader;
import java.io.File;
import java.util.HashMap;
import java.util.Map;

public class ModelPool {
  public static ModelPoolEntry addFile(String file, Class<ModelPoolEntry> modelClass, Map<String, TransformGroup> group, Map<String, TextureGroup> textureGroup) {
    ModelPoolEntry entry = null;
    if (modelMap.containsKey(file)) {
      entry = modelMap.get(file);
      entry.applyGroups(group, textureGroup);
      return entry;
    } 
    try {
      entry = modelClass.newInstance();
    } catch (Exception e) {
      System.out.println("A new " + entry.getClass().getName() + " could not be initialized.");
      System.out.println(e.getMessage());
      return null;
    } 
    File modelFile = null;
    for (int i = 0; i < resourceDir.length && (modelFile == null || !modelFile.exists()); i++) {
      String absPath = (new File(Loader.instance().getConfigDir().getParent(), resourceDir[i])).getAbsolutePath();
      if (!absPath.endsWith("/") || !absPath.endsWith("\\"))
        absPath = absPath + "/"; 
      modelFile = entry.checkValidPath(absPath + file);
    } 
    if (modelFile == null || !modelFile.exists()) {
      System.out.println("The model with the name " + file + " does not exist.");
      return null;
    } 
    entry.groups = new HashMap<Object, Object>();
    entry.textures = new HashMap<Object, Object>();
    entry.name = file;
    entry.setGroup("0");
    entry.setTextureGroup("0");
    entry.getModel(modelFile);
    entry.applyGroups(group, textureGroup);
    modelMap.put(file, entry);
    return entry;
  }
  
  private static Map<String, ModelPoolEntry> modelMap = new HashMap<String, ModelPoolEntry>();
  
  private static String[] resourceDir = new String[] { "/resources/models/", "/resources/mod/models/" };
  
  public static final Class OBJ = ModelPoolObjEntry.class;
}
